-module(ebb_pipe).
-export([pipe/2, pipe/1, bind/2, feed/2, sequence/2, sequence/1]).

pipe(Op1, Op2) ->
    flow_graph:pipe([Op1, Op2]).

pipe([Op]) ->
    Op;
pipe(Ops = [_|_]) ->
    flow_graph:pipe(Ops).

bind(Task, Gen) ->
    feed(Task, ebb_prim:dynamic(Gen)).

feed(Task, Op) ->
    flow_graph:pipe([Task, Op]).

sequence(Task1, Task2) ->
    flow_graph:sequence([Task1, Task2]).

sequence([Task]) ->
    Task;
sequence(Tasks = [_|_]) ->
    flow_graph:sequence(Tasks).
