-module(ebb_prim).
-export([task/2, task/1, return/1,
	 func/1, app/2, dynamic/1,
	 ignore/1, nop/0, id/0]).

task(Func, Arg) ->
    app(dynamic(Func), return(Arg)).

task(Thunk) ->
    flow_graph:dynamic(Thunk).

return(Val) ->
    flow_graph:value(Val).

func(Func) ->
    flow_graph:func(Func).

app(Op, Arg) ->
    flow_graph:pipe(return(Arg), Op).

dynamic(Gen) ->
    flow_graph:dynamic(Gen).

ignore(Task) ->
    flow_graph:sequence([flow_graph:route(1, []), Task]).

nop() ->
    flow_graph:value('nop').

id() ->
    flow_graph:route(1, [1]).
